package it.unibo.tw0708.web.more;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class AddictionFilter 
implements Filter {

   private FilterConfig filterConfig = null;

   public void init(FilterConfig filterConfig) 
   throws ServletException {
      this.filterConfig = filterConfig;
   }

   public void destroy() {
      this.filterConfig = null;
   }

   // my logic
   
   private static final String COUNTER = "counter";
   
   public void doFilter(ServletRequest request, ServletResponse response, FilterChain chain) 
   throws IOException, ServletException {

	   if (filterConfig == null)
	         return;
	   
	   try {

		   Cookie[] cookies = ((HttpServletRequest)request).getCookies();
		   Cookie counter = null;

		   if ( cookies != null && cookies.length > 0 ) {
			   for ( Cookie candidate : cookies ) {
				   if ( candidate.getName().equals(COUNTER) ) {
					   counter = candidate;
					   break;
				   }
			   }
		   }
		   
		   if ( counter == null ) {
			   // aggiungo un contatore
			   ((HttpServletResponse)response).addCookie(new Cookie(COUNTER,""+1));
			   // proseguo a servire la richiesta dell'utente
		      chain.doFilter(request, response);
		   }
		   else {
			   int count = Integer.parseInt(counter.getValue());
			   if ( count >= 3 ) {
				   // resetto il contatore
				   ((HttpServletResponse)response).addCookie(new Cookie(COUNTER,""+0));
				   // interrompo la richiesta dell'utente
				   request.getRequestDispatcher("/toomuchlove").forward(request, response);
			   }
			   else {
				   ((HttpServletResponse)response).addCookie(new Cookie(COUNTER,""+ (count+1) ) );
				   // proseguo a servire la richiesta dell'utente
			      chain.doFilter(request, response);
			   }
		   }

	   }
	   catch (Exception e) {
		   // faccio finta di niente e proseguo a servire la richiesta dell'utente
		      chain.doFilter(request, response);
	   }

   }//doFilter()

}