package it.unibo.tw0708.web.more;

import static it.unibo.tw0708.web.utils.HtmlPrintWriter.BODY;
import static it.unibo.tw0708.web.utils.HtmlPrintWriter.HEAD;
import static it.unibo.tw0708.web.utils.HtmlPrintWriter.HTML;
import it.unibo.tw0708.web.utils.HtmlPrintWriter;
import it.unibo.tw0708.web.utils.HtmlPrintWriter.HtmlAttribute;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * A Valentine's Day Servlet
 *
 * @author pisi79
 */
public class TooMuchLoveServlet 
extends HttpServlet {
	
	private static final long serialVersionUID = -7822739649809280754L;

	/**
	 * This servlet forwards the request processing of HTTP POST requests
	 * to the method handling HTTP GET ones.
	 * This way, the servlet can be invoked by submitting both request types
	 */
	public void doPost(HttpServletRequest request,
            HttpServletResponse response)
    throws IOException, ServletException {
    	this.doGet(request,response);
    }

	/**
	 * Requests are served by invoking library functions
	 * and returning html-wrapped results 
	 */
    public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {

    	// this is where we are gonna write html results
        PrintWriter out = response.getWriter();

        /*
         * You can do this way, if you like.
         * But me it's simply unbearable: I just can't stand all those '<' and '>'
         * That's why I created a util class do to that on my behalf
         * 
        out.println("<html>");
        out.println("<head>");
         */
        
        HtmlPrintWriter myout = new HtmlPrintWriter(out);

        myout.open( HtmlPrintWriter.HTML, null );		

	        /*
	         * ..or, by statically importing the static properties from HtmlUtils class
	         */
	        myout.open( HEAD, null ); 
	
		        // title
			    myout.element("title",null,"Valentine's Day Servlet");
		
			    // style
			    HtmlAttribute rel = myout.new HtmlAttribute("rel","stylesheet");
			    HtmlAttribute href = myout.new HtmlAttribute("href","styles/valentine.css");
			    HtmlAttribute type = myout.new HtmlAttribute("type","text/css");
			    myout.element("link",new HtmlAttribute[]{ rel, href, type },null );
	
		    myout.close( HEAD ); 
	
	        myout.open( BODY, null ); 

	        	myout.open( "div", new HtmlAttribute[]{ myout.new HtmlAttribute("id","main") } );

			        String result = "";
			        try {
			            result += "Too much love will kill you!"; 
			            result += "<br/>";	// the utility method to make this is missing!! 
			        }
			        catch (Exception e) {
			        	// we just don't print any score in case of trouble
			        	result = "";
					}
			        result += "<br/>";
	
			        // out.println(result);
			        myout.getWriter().println(result);		
		        
		        myout.close("div");

	        myout.close( BODY );
	        
        myout.close( HTML );

    }

}



